update uwproj newapi

Sun, 07 Apr 2024 11:26:38 +0200

author
Olaf Wintermann <olaf.wintermann@gmail.com>
date
Sun, 07 Apr 2024 11:26:38 +0200
branch
newapi
changeset 277
5099a34747c4
parent 276
376921880a7f
child 278
a8faf8757450

update uwproj

application/Makefile file | annotate | diff | comparison | revisions
configure file | annotate | diff | comparison | revisions
make/cc.mk file | annotate | diff | comparison | revisions
make/clang.mk file | annotate | diff | comparison | revisions
make/configure.vm file | annotate | diff | comparison | revisions
make/gcc.mk file | annotate | diff | comparison | revisions
make/project.xml file | annotate | diff | comparison | revisions
make/suncc.mk file | annotate | diff | comparison | revisions
make/toolchain.sh file | annotate | diff | comparison | revisions
make/uwproj.xsd file | annotate | diff | comparison | revisions
--- a/application/Makefile	Sun Mar 31 18:29:06 2024 +0200
+++ b/application/Makefile	Sun Apr 07 11:26:38 2024 +0200
@@ -38,7 +38,7 @@
 all: ../build/bin/mk12
 
 ../build/bin/mk12: $(OBJ) $(BUILD_ROOT)/build/lib/libuitk.a
-	$(LD) -o ../build/bin/mk12$(APP_EXT) $(OBJ) -L$(BUILD_ROOT)/build/lib -luitk -lucx $(LDFLAGS) $(TK_LDFLAGS)
+	$(CC) -o ../build/bin/mk12$(APP_EXT) $(OBJ) -L$(BUILD_ROOT)/build/lib -luitk -lucx $(LDFLAGS) $(TK_LDFLAGS)
 
 ../build/application/%.$(OBJ_EXT): %.c
 	$(CC) ../ucx $(CFLAGS) $(TK_CFLAGS) -o $@ -c $<
--- a/configure	Sun Mar 31 18:29:06 2024 +0200
+++ b/configure	Sun Apr 07 11:26:38 2024 +0200
@@ -1,40 +1,53 @@
 #!/bin/sh
 
-
-PREFIX=/usr
-EPREFIX=$PREFIX
+# create temporary directory
+TEMP_DIR=".tmp-`uname -n`"
+rm -Rf "$TEMP_DIR"
+if mkdir -p "$TEMP_DIR"; then
+    :
+else
+    echo "Cannot create tmp dir $TEMP_DIR"
+    echo "Abort"
+    exit 1
+fi
+touch "$TEMP_DIR/options"
+touch "$TEMP_DIR/features"
 
-BINDIR=
-SBINDIR=
-LIBDIR=
-LIBEXECDIR=
-DATADIR=
-SYSCONFDIR=
-SHAREDSTATEDIR=
-LOCALSTATEDIR=
-INCLUDEDIR=
-INFODIR=
-MANDIR=
+# define standard variables
+# also define standard prefix (this is where we will search for config.site)
+prefix=/usr
+exec_prefix=
+bindir=
+sbindir=
+libdir=
+libexecdir=
+datarootdir=
+datadir=
+sysconfdir=
+sharedstatedir=
+localstatedir=
+runstatedir=
+includedir=
+infodir=
+localedir=
+mandir=
 
-OS=`uname -s`
-OS_VERSION=`uname -r`
-
-TEMP_DIR=".tmp-`uname -n`"
-mkdir -p $TEMP_DIR
-if [ $? -ne 0 ]; then
-	echo "Cannot create tmp dir"
-	echo "Abort"
-fi
-touch $TEMP_DIR/options
-touch $TEMP_DIR/features
+# custom variables
 
 # features
 
+# clean abort
+abort_configure()
+{
+    rm -Rf "$TEMP_DIR"
+    exit 1
+}
+
 # help text
 printhelp()
 {
-	echo "Usage: $0 [OPTIONS]..."
-	cat << __EOF__
+    echo "Usage: $0 [OPTIONS]..."
+    cat << __EOF__
 Installation directories:
   --prefix=PREFIX         path prefix for architecture-independent files
                           [/usr]
@@ -47,497 +60,482 @@
   --sysconfdir=DIR        system configuration files [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       run-time variable data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --datarootdir=DIR       read-only arch.-independent data root [PREFIX/share]
   --datadir=DIR           read-only architecture-independent data [DATAROOTDIR]
   --infodir=DIR           info documentation [DATAROOTDIR/info]
   --mandir=DIR            man documentation [DATAROOTDIR/man]
+  --localedir=DIR         locale-dependent data [DATAROOTDIR/locale]
 
 Options:
+  --debug                 add extra compile flags for debug builds
+  --release               add extra compile flags for release builds
   --toolkit=(gtk4|gtk3|gtk2|gtk2legacy|qt5|qt4|motif)
 
 __EOF__
 }
 
 #
-# parse arguments 
+# parse arguments
 #
-for ARG in $@
+BUILD_TYPE="default"
+for ARG in "$@"
 do
     case "$ARG" in
-		"--prefix="*)         PREFIX=${ARG#--prefix=} ;;
-		"--exec-prefix="*)    EPREFIX=${ARG#--exec-prefix=} ;;
-		"--bindir="*)         BINDIR=${ARG#----bindir=} ;;
-		"--sbindir="*)        SBINDIR=${ARG#--sbindir=} ;;
-		"--libdir="*)         LIBDIR=${ARG#--libdir=} ;;
-		"--libexecdir="*)     LIBEXECDIR=${ARG#--libexecdir=} ;;
-		"--datadir="*)        DATADIR=${ARG#--datadir=} ;;
-		"--sysconfdir="*)     SYSCONFDIR=${ARG#--sysconfdir=} ;;
-		"--sharedstatedir="*) SHAREDSTATEDIR=${ARG#--sharedstatedir=} ;;
-		"--localstatedir="*)  LOCALSTATEDIR=${ARG#--localstatedir=} ;;
-		"--includedir="*)     INCLUDEDIR=${ARG#--includedir=} ;;
-		"--infodir="*)        INFODIR=${ARG#--infodir=} ;;
-		"--mandir"*)          MANDIR=${ARG#--mandir} ;;
-		"--help"*) printhelp; exit 1 ;;
-    	"--toolkit="*) OPT_TOOLKIT=${ARG#--toolkit=} ;;
-		"-"*) echo "unknown option: $ARG"; exit 1 ;;
-	esac
+        "--prefix="*)         prefix=${ARG#--prefix=} ;;
+        "--exec-prefix="*)    exec_prefix=${ARG#--exec-prefix=} ;;
+        "--bindir="*)         bindir=${ARG#----bindir=} ;;
+        "--sbindir="*)        sbindir=${ARG#--sbindir=} ;;
+        "--libdir="*)         libdir=${ARG#--libdir=} ;;
+        "--libexecdir="*)     libexecdir=${ARG#--libexecdir=} ;;
+        "--datarootdir="*)    datarootdir=${ARG#--datarootdir=} ;;
+        "--datadir="*)        datadir=${ARG#--datadir=} ;;
+        "--sysconfdir="*)     sysconfdir=${ARG#--sysconfdir=} ;;
+        "--sharedstatedir="*) sharedstatedir=${ARG#--sharedstatedir=} ;;
+        "--localstatedir="*)  localstatedir=${ARG#--localstatedir=} ;;
+        "--includedir="*)     includedir=${ARG#--includedir=} ;;
+        "--infodir="*)        infodir=${ARG#--infodir=} ;;
+        "--mandir"*)          mandir=${ARG#--mandir} ;;
+        "--localedir"*)       localedir=${ARG#--localedir} ;;
+        "--help"*) printhelp; abort_configure ;;
+        "--debug")           BUILD_TYPE="debug" ;;
+        "--release")         BUILD_TYPE="release" ;;
+        "--toolkit="*) OPT_TOOLKIT=${ARG#--toolkit=} ;;
+        "-"*) echo "unknown option: $ARG"; abort_configure ;;
+    esac
 done
 
-# set dir variables
-if [ -z "$BINDIR" ]; then
-	BINDIR=$EPREFIX/bin
-fi
-if [ -z "$SBINDIR" ]; then
-	SBINDIR=$EPREFIX/sbin
-fi
-if [ -z "$LIBDIR" ]; then
-	LIBDIR=$EPREFIX/lib
-fi
-if [ -z "$LIBEXEC" ]; then
-	LIBEXECDIR=$EPREFIX/libexec
-fi
-if [ -z "$DATADIR" ]; then
-	DATADIR=$PREFIX/share
-fi
-if [ -z "$SYSCONFDIR" ]; then
-	SYSCONFDIR=$PREFIX/etc
-fi
-if [ -z "$SHAREDSTATEDIR" ]; then
-	SHAREDSTATEDIR=$PREFIX/com
-fi
-if [ -z "$LOCALSTATEDIR" ]; then
-	LOCALSTATEDIR=$PREFIX/var
-fi
-if [ -z "$INCLUDEDIR" ]; then
-	INCLUDEDIR=$PREFIX/include
-fi
-if [ -z "$INFODIR" ]; then
-	INFODIR=$PREFIX/info
-fi
-if [ -z "$MANDIR" ]; then
-	MANDIR=$PREFIX/man
+
+
+# set defaults for dir variables
+: ${exec_prefix:="$prefix"}
+: ${bindir:='${exec_prefix}/bin'}
+: ${sbindir:='${exec_prefix}/sbin'}
+: ${libdir:='${exec_prefix}/lib'}
+: ${libexecdir:='${exec_prefix}/libexec'}
+: ${datarootdir:='${prefix}/share'}
+: ${datadir:='${datarootdir}'}
+: ${sysconfdir:='${prefix}/etc'}
+: ${sharedstatedir:='${prefix}/com'}
+: ${localstatedir:='${prefix}/var'}
+: ${runstatedir:='${localstatedir}/run'}
+: ${includedir:='${prefix}/include'}
+: ${infodir:='${datarootdir}/info'}
+: ${mandir:='${datarootdir}/man'}
+: ${localedir:='${datarootdir}/locale'}
+
+# check if a config.site exists and load it
+if [ -n "$CONFIG_SITE" ]; then
+    # CONFIG_SITE may contain space separated file names
+    for cs in $CONFIG_SITE; do
+        printf "loading defaults from $cs... "
+        . "$cs"
+        echo ok
+    done
+elif [ -f "$prefix/share/config.site" ]; then
+    printf "loading site defaults... "
+    . "$prefix/share/config.site"
+    echo ok
+elif [ -f "$prefix/etc/config.site" ]; then
+    printf "loading site defaults... "
+    . "$prefix/etc/config.site"
+    echo ok
 fi
 
-which pkg-config > /dev/null
-if [ $? -eq 0 ]; then
-    PKG_CONFIG=pkg-config
-else
-    PKG_CONFIG=false
-fi
+# Test for availability of pkg-config
+PKG_CONFIG=`command -v pkg-config`
+: ${PKG_CONFIG:="false"}
 
 # Simple uname based platform detection
 # $PLATFORM is used for platform dependent dependency selection
+OS=`uname -s`
+OS_VERSION=`uname -r`
 printf "detect platform... "
-if [ $OS = SunOS ]; then
+if [ "$OS" = "SunOS" ]; then
     PLATFORM="solaris sunos unix svr4"
-fi
-if [ $OS = Linux ]; then
+elif [ "$OS" = "Linux" ]; then
     PLATFORM="linux unix"
-fi
-if [ $OS = FreeBSD ]; then
+elif [ "$OS" = "FreeBSD" ]; then
     PLATFORM="freebsd bsd unix"
-fi
-if [ $OS = Darwin ]; then
+elif [ "$OS" = "OpenBSD" ]; then
+    PLATFORM="openbsd bsd unix"
+elif [ "$OS" = "NetBSD" ]; then
+    PLATFORM="netbsd bsd unix"
+elif [ "$OS" = "Darwin" ]; then
     PLATFORM="macos osx bsd unix"
-fi
-echo $OS | grep "MINGW" > /dev/null
-if [ $? -eq 0 ]; then
+elif echo "$OS" | grep -i "MINGW" > /dev/null; then
     PLATFORM="windows mingw"
 fi
-
-if [ -z "$PLATFORM" ]; then
-    PLATFORM="unix"
-fi
+: ${PLATFORM:="unix"}
 
-for p in $PLATFORM
-do
-	PLATFORM_NAME=$p
-	break
-done
-echo $PLATFORM_NAME
+PLATFORM_NAME=`echo "$PLATFORM" | cut -f1 -d' ' -`
+echo "$PLATFORM_NAME"
 
 isplatform()
 {
     for p in $PLATFORM
     do
-        if [ $p = $1 ]; then
+        if [ "$p" = "$1" ]; then
             return 0
         fi
     done
     return 1
 }
-isnotplatform()
+notisplatform()
 {
     for p in $PLATFORM
     do
-        if [ $p = $1 ]; then
+        if [ "$p" = "$1" ]; then
+            return 1
+        fi
+    done
+    return 0
+}
+istoolchain()
+{
+    for t in $TOOLCHAIN
+    do
+        if [ "$t" = "$1" ]; then
+            return 0
+        fi
+    done
+    return 1
+}
+notistoolchain()
+{
+    for t in $TOOLCHAIN
+    do
+        if [ "$t" = "$1" ]; then
             return 1
         fi
     done
     return 0
 }
 
-# generate config.mk and config.h
-cat > $TEMP_DIR/config.mk << __EOF__
-#
-# config.mk generated by configure
-#
 
-# general vars
-
-PREFIX=$PREFIX
-EPREFIX=$EPREFIX
-
-BINDIR=$BINDIR
-SBINDIR=$SBINDIR
-LIBDIR=$LIBDIR
-LIBEXECDIR=$LIBEXECDIR
-DATADIR=$DATADIR
-SYSCONFDIR=$SYSCONFDIR
-SHAREDSTATEDIR=$SHAREDSTATEDIR
-LOCALSTATEDIR=$LOCALSTATEDIR
-INCLUDEDIR=$INCLUDEDIR
-INFODIR=$INFODIR
-MANDIR=$MANDIR
-
+# generate vars.mk
+cat > "$TEMP_DIR/vars.mk" << __EOF__
+prefix=$prefix
+exec_prefix=$exec_prefix
+bindir=$bindir
+sbindir=$sbindir
+libdir=$libdir
+libexecdir=$libexecdir
+datarootdir=$datarootdir
+datadir=$datadir
+sysconfdir=$sysconfdir
+sharedstatedir=$sharedstatedir
+localstatedir=$localstatedir
+runstatedir=$runstatedir
+includedir=$includedir
+infodir=$infodir
+mandir=$mandir
+localedir=$localedir
 __EOF__
 
-echo > $TEMP_DIR/make.mk
-
-ENV_CFLAGS=$CFLAGS
-ENV_LDFLAGS=$LDFLAGS
-ENV_CXXFLAGS=$CXXFLAGS
-
-# Toolchain detection
-# this will insert make vars to config.mk
+# toolchain detection utilities
 . make/toolchain.sh
 
-# add user specified flags to config.mk
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${ENV_CFLAGS}" ]; then
-    echo "CFLAGS += $ENV_CFLAGS" >> $TEMP_DIR/config.mk
-fi
-if [ ! -z "${ENV_CXXFLAGS}" ]; then
-    echo "CXXFLAGS += $ENV_CXXFLAGS" >> $TEMP_DIR/config.mk
-fi
-if [ ! -z "${ENV_LDFLAGS}" ]; then
-    echo "LDFLAGS += $ENV_LDFLAGS" >> $TEMP_DIR/config.mk
-fi
-
 #
 # DEPENDENCIES
 #
 
-dependency_qt4()
+# check languages
+lang_c=
+lang_cpp=
+if detect_c_compiler ; then
+    lang_c=1
+fi
+
+# create buffer for make variables required by dependencies
+echo > "$TEMP_DIR/make.mk"
+
+test_pkg_config()
 {
-    printf "checking for qt4... "
-    # dependency qt4 
-    while true
-    do
-        qmake-qt4 -o - /dev/null | grep DEFINES\  > /dev/null
-        if [ $? -eq 0 ]; then
-            CFLAGS="$CFLAGS `qmake-qt4 -o - /dev/null | grep DEFINES\ `"
-        else
-            break
-        fi
-        qmake-qt4 -o - /dev/null | grep INCPATH\  > /dev/null
-        if [ $? -eq 0 ]; then
-            CFLAGS="$CFLAGS `qmake-qt4 -o - /dev/null | grep INCPATH\ `"
-        else
-            break
-        fi
-         > /dev/null
-        if [ $? -eq 0 ]; then
-            LDFLAGS="$LDFLAGS ``"
-        else
-            break
-        fi
-        which qmake-qt4 > /dev/null
-        if [ $? -ne 0 ]; then
-        	break
-        fi
-		echo yes
-        return 0
-    done
-	
-	echo no
-	return 1
+    if "$PKG_CONFIG" --exists "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$2" ] || "$PKG_CONFIG" --atleast-version="$2" "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$3" ] || "$PKG_CONFIG" --exact-version="$3" "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$4" ] || "$PKG_CONFIG" --max-version="$4" "$1" ; then :
+    else return 1 ; fi
+    return 0
 }
-dependency_gtk2legacy()
+
+print_check_msg()
 {
-    printf "checking for gtk2legacy... "
-    # dependency gtk2legacy 
+    if [ -z "$1" ]; then
+        shift
+        printf "$@"
+    fi
+}
+
+dependency_error_gtk2legacy()
+{
+    print_check_msg "$dep_checked_gtk2legacy" "checking for gtk2legacy... "
+    # dependency gtk2legacy
     while true
     do
         if [ -z "$PKG_CONFIG" ]; then
-        	break
-        fi
-		$PKG_CONFIG gtk+-2.0
-        if [ $? -ne 0 ] ; then
             break
         fi
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags gtk+-2.0`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs gtk+-2.0`"
-        CFLAGS="$CFLAGS -DUI_GTK2 -DUI_GTK2LEGACY"    
-        LDFLAGS="$LDFLAGS -lpthread"    
-		echo yes
-        return 0
-    done
-	
-	echo no
-	return 1
-}
-dependency_qt5()
-{
-    printf "checking for qt5... "
-    # dependency qt5 
-    while true
-    do
-        qmake-qt5 -o - /dev/null | grep DEFINES\  > /dev/null
-        if [ $? -eq 0 ]; then
-            CFLAGS="$CFLAGS `qmake-qt5 -o - /dev/null | grep DEFINES\ `"
+        if test_pkg_config "gtk+-2.0" "" "" "" ; then
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags gtk+-2.0`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs gtk+-2.0`"
         else
             break
         fi
-        qmake-qt5 -o - /dev/null | grep INCPATH\  > /dev/null
-        if [ $? -eq 0 ]; then
-            CFLAGS="$CFLAGS `qmake-qt5 -o - /dev/null | grep INCPATH\ `"
-        else
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_GTK2 -DUI_GTK2LEGACY"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lpthread"
+        print_check_msg "$dep_checked_gtk2legacy" "yes\n"
+        dep_checked_gtk2legacy=1
+        return 1
+    done
+
+    print_check_msg "$dep_checked_gtk2legacy" "no\n"
+    dep_checked_gtk2legacy=1
+    return 0
+}
+dependency_error_gtk2()
+{
+    print_check_msg "$dep_checked_gtk2" "checking for gtk2... "
+    # dependency gtk2
+    while true
+    do
+        if [ -z "$PKG_CONFIG" ]; then
             break
         fi
-         > /dev/null
-        if [ $? -eq 0 ]; then
-            LDFLAGS="$LDFLAGS ``"
+        if pkg-config --atleast-version=2.20 gtk+-2.0 > /dev/null ; then
+            :
         else
             break
         fi
-        which qmake-qt5 > /dev/null
-        if [ $? -ne 0 ]; then
-        	break
+        if test_pkg_config "gtk+-2.0" "" "" "" ; then
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags gtk+-2.0`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs gtk+-2.0`"
+        else
+            break
         fi
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_GTK2"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lpthread"
+        print_check_msg "$dep_checked_gtk2" "yes\n"
+        dep_checked_gtk2=1
+        return 1
     done
-	
-	echo no
-	return 1
+
+    print_check_msg "$dep_checked_gtk2" "no\n"
+    dep_checked_gtk2=1
+    return 0
 }
-dependency_gtk2()
+dependency_error_gtk3()
 {
-    printf "checking for gtk2... "
-    # dependency gtk2 
+    print_check_msg "$dep_checked_gtk3" "checking for gtk3... "
+    # dependency gtk3
     while true
     do
         if [ -z "$PKG_CONFIG" ]; then
-        	break
+            break
         fi
-		$PKG_CONFIG gtk+-2.0
-        if [ $? -ne 0 ] ; then
+        if test_pkg_config "gtk+-3.0" "" "" "" ; then
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags gtk+-3.0`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs gtk+-3.0`"
+        else
             break
         fi
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags gtk+-2.0`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs gtk+-2.0`"
-        CFLAGS="$CFLAGS -DUI_GTK2"    
-        LDFLAGS="$LDFLAGS -lpthread"    
-        pkg-config --atleast-version=2.20 gtk+-2.0 > /dev/null
-        if [ $? -ne 0 ]; then
-        	break
-        fi
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_GTK3"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lpthread"
+        print_check_msg "$dep_checked_gtk3" "yes\n"
+        dep_checked_gtk3=1
+        return 1
     done
-	
-	echo no
-	return 1
+
+    print_check_msg "$dep_checked_gtk3" "no\n"
+    dep_checked_gtk3=1
+    return 0
 }
-dependency_gtk3()
+dependency_error_gtk4()
 {
-    printf "checking for gtk3... "
-    # dependency gtk3 
-    while true
-    do
-        if [ -z "$PKG_CONFIG" ]; then
-        	break
-        fi
-		$PKG_CONFIG gtk+-3.0
-        if [ $? -ne 0 ] ; then
-            break
-        fi
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags gtk+-3.0`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs gtk+-3.0`"
-        CFLAGS="$CFLAGS -DUI_GTK3"    
-        LDFLAGS="$LDFLAGS -lpthread"    
-		echo yes
-        return 0
-    done
-	
-	echo no
-	return 1
-}
-dependency_gtk4()
-{
-    printf "checking for gtk4... "
-    # dependency gtk4 
+    print_check_msg "$dep_checked_gtk4" "checking for gtk4... "
+    # dependency gtk4
     while true
     do
         if [ -z "$PKG_CONFIG" ]; then
-        	break
+            break
         fi
-		$PKG_CONFIG gtk+-4.0
-        if [ $? -ne 0 ] ; then
+        if test_pkg_config "gtk+-4.0" "" "" "" ; then
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags gtk+-4.0`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs gtk+-4.0`"
+        else
             break
         fi
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags gtk+-4.0`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs gtk+-4.0`"
-        CFLAGS="$CFLAGS -DUI_GTK3"    
-        LDFLAGS="$LDFLAGS -lpthread"    
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_GTK3"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lpthread"
+        print_check_msg "$dep_checked_gtk4" "yes\n"
+        dep_checked_gtk4=1
+        return 1
     done
-	
-	echo no
-	return 1
+
+    print_check_msg "$dep_checked_gtk4" "no\n"
+    dep_checked_gtk4=1
+    return 0
 }
-dependency_motif()
+dependency_error_motif()
 {
-    printf "checking for motif... "
+    print_check_msg "$dep_checked_motif" "checking for motif... "
     # dependency motif platform="bsd"
     while true
     do
-    	if isnotplatform "bsd"; then
+        if notisplatform "bsd"; then
             break
         fi
-        CFLAGS="$CFLAGS -DUI_MOTIF -I/usr/local/include/X11"    
-        LDFLAGS="$LDFLAGS -lXm -lXt -lX11 -lpthread"    
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_MOTIF -I/usr/local/include/X11"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lXm -lXt -lX11 -lpthread"
+        print_check_msg "$dep_checked_motif" "yes\n"
+        dep_checked_motif=1
+        return 1
     done
-	
-    # dependency motif 
+
+    # dependency motif
     while true
     do
-        CFLAGS="$CFLAGS -DUI_MOTIF"    
-        LDFLAGS="$LDFLAGS -lXm -lXt -lX11 -lpthread"    
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_MOTIF"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lXm -lXt -lX11 -lpthread"
+        print_check_msg "$dep_checked_motif" "yes\n"
+        dep_checked_motif=1
+        return 1
     done
-	
-	echo no
-	return 1
+
+    print_check_msg "$dep_checked_motif" "no\n"
+    dep_checked_motif=1
+    return 0
 }
-dependency_winui()
+dependency_error_cocoa()
 {
-    printf "checking for winui... "
+    print_check_msg "$dep_checked_cocoa" "checking for cocoa... "
+    # dependency cocoa platform="macos"
+    while true
+    do
+        if notisplatform "macos"; then
+            break
+        fi
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_COCOA"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -lobjc -framework Cocoa"
+        print_check_msg "$dep_checked_cocoa" "yes\n"
+        dep_checked_cocoa=1
+        return 1
+    done
+
+    print_check_msg "$dep_checked_cocoa" "no\n"
+    dep_checked_cocoa=1
+    return 0
+}
+dependency_error_winui()
+{
+    print_check_msg "$dep_checked_winui" "checking for winui... "
     # dependency winui platform="windows"
     while true
     do
-    	if isnotplatform "windows"; then
+        if notisplatform "windows"; then
             break
         fi
-        CFLAGS="$CFLAGS -DUI_WINUI"    
-		echo yes
-        return 0
+        TEMP_CFLAGS="$TEMP_CFLAGS -DUI_WINUI"
+        print_check_msg "$dep_checked_winui" "yes\n"
+        dep_checked_winui=1
+        return 1
     done
-	
-	echo no
-	return 1
+
+    print_check_msg "$dep_checked_winui" "no\n"
+    dep_checked_winui=1
+    return 0
 }
-dependency_cocoa()
-{
-    printf "checking for cocoa... "
-    # dependency cocoa platform="macos"
-    while true
-    do
-    	if isnotplatform "macos"; then
-            break
-        fi
-        CFLAGS="$CFLAGS -DUI_COCOA"    
-        LDFLAGS="$LDFLAGS -lobjc -framework Cocoa"    
-		echo yes
-        return 0
-    done
-	
-	echo no
-	return 1
-}
+
+# start collecting dependency information
+echo > "$TEMP_DIR/flags.mk"
 
 DEPENDENCIES_FAILED=
 ERROR=0
-# general dependencies
-CFLAGS=
-LDFLAGS=
+# unnamed dependencies
+TEMP_CFLAGS=
+TEMP_CXXFLAGS=
+TEMP_LDFLAGS=
 while true
 do
-    if isnotplatform "macos"; then
+    while true
+    do
+        if [ -z "$lang_c" ] ; then
+            ERROR=1
+            break
+        fi
+
+        break
+    done
+    break
+done
+while true
+do
+    if notisplatform "macos"; then
         break
     fi
     while true
     do
-        
-		cat >> $TEMP_DIR/make.mk << __EOF__
+
+        cat >> "$TEMP_DIR/make.mk" << __EOF__
 OBJ_EXT = .o
 LIB_EXT = .a
 PACKAGE_SCRIPT = package_osx.sh
-
 __EOF__
-        
         break
     done
-    
     break
 done
 while true
 do
-    if isnotplatform "unix"; then
+    if notisplatform "unix"; then
         break
     fi
-    if isplatform "macos"; then
+    if isplatform "macos" || istoolchain "macos"; then
         break
     fi
     while true
     do
-        
-		cat >> $TEMP_DIR/make.mk << __EOF__
+
+        cat >> "$TEMP_DIR/make.mk" << __EOF__
 OBJ_EXT = .o
 LIB_EXT = .a
 PACKAGE_SCRIPT = package_unix.sh
-
 __EOF__
-        
         break
     done
-    
     break
 done
 while true
 do
-    if isnotplatform "bsd"; then
+    if notisplatform "bsd"; then
         break
     fi
     while true
     do
-        
-        CFLAGS="$CFLAGS -I/usr/local/include"    
-        LDFLAGS="$LDFLAGS -L/usr/local/lib"    
-        
+
+        TEMP_CFLAGS="$TEMP_CFLAGS -I/usr/local/include"
+        TEMP_LDFLAGS="$TEMP_LDFLAGS -L/usr/local/lib"
         break
     done
-    
     break
 done
 
-# add general dependency flags to config.mk
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${CFLAGS}" ]; then
-    echo "CFLAGS += $CFLAGS" >> $TEMP_DIR/config.mk
+# add general dependency flags to flags.mk
+echo "# general flags" >> "$TEMP_DIR/flags.mk"
+if [ -n "${TEMP_CFLAGS}" ] && [ -n "$lang_c" ]; then
+    echo "CFLAGS += $TEMP_CFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${CXXFLAGS}" ]; then
-    echo "CXXFLAGS += $CXXFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_CXXFLAGS}" ] && [ -n "$lang_cpp" ]; then
+    echo "CXXFLAGS += $TEMP_CXXFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${LDFLAGS}" ]; then
-    echo "LDFLAGS += $LDFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_LDFLAGS}" ]; then
+    echo "LDFLAGS += $TEMP_LDFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
 
 #
@@ -545,274 +543,292 @@
 #
 checkopt_toolkit_gtk4()
 {
-	VERR=0
-	dependency_gtk4
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_gtk4 ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = gtk
 GTKOBJ = draw_cairo.o
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_gtk3()
 {
-	VERR=0
-	dependency_gtk3
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_gtk3 ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = gtk
 GTKOBJ = draw_cairo.o
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_gtk2()
 {
-	VERR=0
-	dependency_gtk2
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_gtk2 ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = gtk
 GTKOBJ = draw_cairo.o
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_gtk2legacy()
 {
-	VERR=0
-	dependency_gtk2legacy
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_gtk2legacy ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = gtk
 GTKOBJ = draw_gdk.o
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_qt5()
 {
-	VERR=0
-	dependency_qt5
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_qt5 ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = qt
 LD = $(CXX)
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_qt4()
 {
-	VERR=0
-	dependency_qt4
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_qt4 ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = qt
 LD = $(CXX)
-
 __EOF__
-	return 0
+    return 0
 }
 checkopt_toolkit_motif()
 {
-	VERR=0
-	dependency_motif
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    if dependency_error_motif ; then
+        VERR=1
+    fi
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 TOOLKIT = motif
-
 __EOF__
-	return 0
+    return 0
 }
 
 #
 # TARGETS
 #
-CFLAGS=
-CXXFLAGS=
-LDFLAGS=
 
-# Target: tk
-CFLAGS=
-LDFLAGS=
-CXXFLAGS=
+echo >> "$TEMP_DIR/flags.mk"
+echo "configuring target: tk"
+echo "# flags for target tk" >> "$TEMP_DIR/flags.mk"
+TEMP_CFLAGS=
+TEMP_CXXFLAGS=
+TEMP_LDFLAGS=
 
 
 # Features
 
 # Option: --toolkit
-if [ -z $OPT_TOOLKIT ]; then
-	SAVED_ERROR=$ERROR
-	SAVED_DEPENDENCIES_FAILED=$DEPENDENCIES_FAILED
-	ERROR=0
-	while true
-	do
-		if isplatform "windows"; then
-		checkopt_toolkit_winui
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: winui" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		fi
-		if isplatform "macos"; then
-		checkopt_toolkit_cocoa
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: cocoa" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		fi
-		checkopt_toolkit_gtk3
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: gtk3" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		checkopt_toolkit_qt5
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: qt5" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		checkopt_toolkit_gtk2
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: gtk2" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		checkopt_toolkit_qt4
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: qt4" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		checkopt_toolkit_motif
-		if [ $? -eq 0 ]; then
-			echo "  toolkit: motif" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		break
-	done
-	if [ $ERROR -ne 0 ]; then
-		SAVED_ERROR=1
-	fi
-	ERROR=$SAVED_ERROR
-	DEPENDENCIES_FAILED=$SAVED_DEPENDENCIES_FAILED=
+if [ -z "$OPT_TOOLKIT" ]; then
+    echo "auto-detecting option 'toolkit'"
+    SAVED_ERROR="$ERROR"
+    SAVED_DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED"
+    ERROR=1
+    while true
+    do
+        if isplatform "windows"; then
+        if checkopt_toolkit_winui ; then
+            echo "  toolkit: winui" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        fi
+        if isplatform "macos"; then
+        if checkopt_toolkit_cocoa ; then
+            echo "  toolkit: cocoa" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        fi
+        if checkopt_toolkit_gtk3 ; then
+            echo "  toolkit: gtk3" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        if checkopt_toolkit_qt5 ; then
+            echo "  toolkit: qt5" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        if checkopt_toolkit_gtk2 ; then
+            echo "  toolkit: gtk2" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        if checkopt_toolkit_qt4 ; then
+            echo "  toolkit: qt4" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        if checkopt_toolkit_motif ; then
+            echo "  toolkit: motif" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        break
+    done
+    if [ $ERROR -ne 0 ]; then
+        SAVED_ERROR=1
+        SAVED_DEPENDENCIES_FAILED="option 'toolkit' $SAVED_DEPENDENCIES_FAILED"
+    fi
+    ERROR="$SAVED_ERROR"
+    DEPENDENCIES_FAILED="$SAVED_DEPENDENCIES_FAILED"
 else
-	if false; then
-		false
-	elif [ $OPT_TOOLKIT = "gtk4" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_gtk4
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "gtk3" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_gtk3
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "gtk2" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_gtk2
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "gtk2legacy" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_gtk2legacy
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "qt5" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_qt5
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "qt4" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_qt4
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	elif [ $OPT_TOOLKIT = "motif" ]; then
-		echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
-		checkopt_toolkit_motif
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	fi
+    echo "checking option toolkit = $OPT_TOOLKIT"
+    if false; then
+        false
+    elif [ "$OPT_TOOLKIT" = "gtk4" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_gtk4 ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "gtk3" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_gtk3 ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "gtk2" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_gtk2 ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "gtk2legacy" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_gtk2legacy ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "qt5" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_qt5 ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "qt4" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_qt4 ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    elif [ "$OPT_TOOLKIT" = "motif" ]; then
+        echo "  toolkit: $OPT_TOOLKIT" >> $TEMP_DIR/options
+        if checkopt_toolkit_motif ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option 'toolkit' $DEPENDENCIES_FAILED"
+        fi
+    fi
 fi
 
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${CFLAGS}" ]; then
-    echo "TK_CFLAGS  += $CFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_CFLAGS}" ] && [ -n "$lang_c" ]; then
+    echo "TK_CFLAGS  += $TEMP_CFLAGS" >> "$TEMP_DIR/flags.mk"
+fi
+if [ -n "${TEMP_CXXFLAGS}" ] && [ -n "$lang_cpp" ]; then
+    echo "TK_CXXFLAGS  += $TEMP_CXXFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${CXXFLAGS}" ]; then
-    echo "TK_CXXFLAGS += $CXXFLAGS" >> $TEMP_DIR/config.mk
+if [ "$BUILD_TYPE" = "debug" ]; then
+    if [ -n "$lang_c" ]; then
+        echo 'TK_CFLAGS += ${DEBUG_CC_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+    if [ -n "$lang_cpp" ]; then
+        echo 'TK_CXXFLAGS += ${DEBUG_CXX_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
 fi
-if [ ! -z "${LDFLAGS}" ]; then
-    echo "TK_LDFLAGS += $LDFLAGS" >> $TEMP_DIR/config.mk
+if [ "$BUILD_TYPE" = "release" ]; then
+    if [ -n "$lang_c" ]; then
+        echo 'TK_CFLAGS += ${RELEASE_CC_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+    if [ -n "$lang_cpp" ]; then
+        echo 'TK_CXXFLAGS += ${RELEASE_CXX_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+fi
+if [ -n "${TEMP_LDFLAGS}" ]; then
+    echo "TK_LDFLAGS += $TEMP_LDFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
 
+
+# final result
 if [ $ERROR -ne 0 ]; then
-	echo
-	echo "Error: Unresolved dependencies"
-	echo $DEPENDENCIES_FAILED
-	rm -Rf $TEMP_DIR
-	exit 1
+    echo
+    echo "Error: Unresolved dependencies"
+    echo "$DEPENDENCIES_FAILED"
+    abort_configure
 fi
 
 echo "configure finished"
 echo
 echo "Build Config:"
-echo "  PREFIX:    $PREFIX"
-echo "  TOOLCHAIN: $TOOLCHAIN_NAME"
+echo "  PREFIX:      $prefix"
+echo "  TOOLCHAIN:   $TOOLCHAIN_NAME"
 echo "Options:"
-cat $TEMP_DIR/options
+cat "$TEMP_DIR/options"
 echo
-cat $TEMP_DIR/config.mk $TEMP_DIR/make.mk > config.mk
-rm -Rf $TEMP_DIR
 
+# generate the config.mk file
+cat > "$TEMP_DIR/config.mk" << __EOF__
+#
+# config.mk generated by configure
+#
 
+__EOF__
+write_toolchain_defaults "$TEMP_DIR/toolchain.mk"
+cat "$TEMP_DIR/vars.mk" "$TEMP_DIR/toolchain.mk" "$TEMP_DIR/flags.mk" "$TEMP_DIR/make.mk" > config.mk
+rm -Rf "$TEMP_DIR"
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/make/cc.mk	Sun Apr 07 11:26:38 2024 +0200
@@ -0,0 +1,14 @@
+#
+# cc toolchain config
+#
+
+CFLAGS =
+CXXFLAGS =
+DEBUG_CC_FLAGS = -g
+DEBUG_CXX_FLAGS = -g
+RELEASE_CC_FLAGS = -O3 -DNDEBUG
+RELEASE_CXX_FLAGS = -O3 -DNDEBUG
+LDFLAGS =
+
+SHLIB_CFLAGS = -fPIC
+SHLIB_LDFLAGS = -shared
\ No newline at end of file
--- a/make/clang.mk	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/clang.mk	Sun Apr 07 11:26:38 2024 +0200
@@ -2,8 +2,13 @@
 # clang toolchain config
 #
 
-CFLAGS = 
-LDFLAGS = 
+CFLAGS =
+CXXFLAGS =
+DEBUG_CC_FLAGS = -g
+DEBUG_CXX_FLAGS = -g
+RELEASE_CC_FLAGS = -O3 -DNDEBUG
+RELEASE_CXX_FLAGS = -O3 -DNDEBUG
+LDFLAGS =
 
 SHLIB_CFLAGS = -fPIC
 SHLIB_LDFLAGS = -shared
--- a/make/configure.vm	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/configure.vm	Sun Apr 07 11:26:38 2024 +0200
@@ -1,78 +1,65 @@
 #!/bin/sh
 
+# create temporary directory
+TEMP_DIR=".tmp-`uname -n`"
+rm -Rf "$TEMP_DIR"
+if mkdir -p "$TEMP_DIR"; then
+    :
+else
+    echo "Cannot create tmp dir $TEMP_DIR"
+    echo "Abort"
+    exit 1
+fi
+touch "$TEMP_DIR/options"
+touch "$TEMP_DIR/features"
+
+# define standard variables
+# also define standard prefix (this is where we will search for config.site)
+prefix=/usr
+exec_prefix=
+bindir=
+sbindir=
+libdir=
+libexecdir=
+datarootdir=
+datadir=
+sysconfdir=
+sharedstatedir=
+localstatedir=
+runstatedir=
+includedir=
+infodir=
+localedir=
+mandir=
+
+# custom variables
 #foreach( $var in $vars )
 #if( $var.exec )
-${var.name}=`${var.value}`
+${var.varName}=`${var.value}`
 #else
-${var.name}=${var.value}
+${var.varName}="${var.value}"
 #end
 #end
 
-#if ( ! $project.hasVar("PREFIX") )
-PREFIX=/usr
+# features
+#foreach( $feature in $features )
+#if( ${feature.auto} )
+${feature.varName}=auto
 #end
-#if ( ! $project.hasVar("EPREFIX") )
-EPREFIX=$PREFIX
 #end
 
-#if ( ! $project.hasVar("BINDIR") )
-BINDIR=
-#end
-#if ( ! $project.hasVar("SBINDIR") )
-SBINDIR=
-#end
-#if ( ! $project.hasVar("LIBDIR") )
-LIBDIR=
-#end
-#if ( ! $project.hasVar("LIBEXECDIR") )
-LIBEXECDIR=
-#end
-#if ( ! $project.hasVar("DATADIR") )
-DATADIR=
-#end
-#if ( ! $project.hasVar("SYSCONFDIR") )
-SYSCONFDIR=
-#end
-#if ( ! $project.hasVar("SHAREDSTATEDIR") )
-SHAREDSTATEDIR=
-#end
-#if ( ! $project.hasVar("LOCALSTATEDIR") )
-LOCALSTATEDIR=
-#end
-#if ( ! $project.hasVar("INCLUDEDIR") )
-INCLUDEDIR=
-#end
-#if ( ! $project.hasVar("INFODIR") )
-INFODIR=
-#end
-#if ( ! $project.hasVar("MANDIR") )
-MANDIR=
-#end
-
-OS=`uname -s`
-OS_VERSION=`uname -r`
-
-TEMP_DIR=".tmp-`uname -n`"
-mkdir -p $TEMP_DIR
-if [ $? -ne 0 ]; then
-	echo "Cannot create tmp dir"
-	echo "Abort"
-fi
-touch $TEMP_DIR/options
-touch $TEMP_DIR/features
-
-# features
-#foreach( $feature in $features )
-#if( ${feature.isDefault()} )
-${feature.getVarName()}=on
-#end
-#end
+# clean abort
+abort_configure()
+{
+    rm -Rf "$TEMP_DIR"
+    exit 1
+}
 
 # help text
 printhelp()
 {
-	echo "Usage: $0 [OPTIONS]..."
-	cat << __EOF__
+    echo "Usage: $0 [OPTIONS]..."
+    cat << __EOF__
 Installation directories:
   --prefix=PREFIX         path prefix for architecture-independent files
                           [/usr]
@@ -85,28 +72,28 @@
   --sysconfdir=DIR        system configuration files [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       run-time variable data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --datarootdir=DIR       read-only arch.-independent data root [PREFIX/share]
   --datadir=DIR           read-only architecture-independent data [DATAROOTDIR]
   --infodir=DIR           info documentation [DATAROOTDIR/info]
   --mandir=DIR            man documentation [DATAROOTDIR/man]
+  --localedir=DIR         locale-dependent data [DATAROOTDIR/locale]
 
 #if( $options.size() > 0 )
 Options:
+  --debug                 add extra compile flags for debug builds
+  --release               add extra compile flags for release builds
 #foreach( $opt in $options )
-  --${opt.getArgument()}=${opt.getValuesString()}
+  --${opt.argument}=${opt.valuesString}
 #end
 
 #end
 #if( $features.size() > 0 )
 Optional Features:
 #foreach( $feature in $features )
-#if( $feature.default )
-  --disable-${feature.arg}
-#else
-  --enable-${feature.arg}
-#end
+${feature.helpText}
 #end
 
 #end
@@ -114,297 +101,328 @@
 }
 
 #
-# parse arguments 
+# parse arguments
 #
+BUILD_TYPE="default"
 #set( $D = '$' )
-for ARG in $@
+for ARG in "$@"
 do
     case "$ARG" in
-		"--prefix="*)         PREFIX=${D}{ARG#--prefix=} ;;
-		"--exec-prefix="*)    EPREFIX=${D}{ARG#--exec-prefix=} ;;
-		"--bindir="*)         BINDIR=${D}{ARG#----bindir=} ;;
-		"--sbindir="*)        SBINDIR=${D}{ARG#--sbindir=} ;;
-		"--libdir="*)         LIBDIR=${D}{ARG#--libdir=} ;;
-		"--libexecdir="*)     LIBEXECDIR=${D}{ARG#--libexecdir=} ;;
-		"--datadir="*)        DATADIR=${D}{ARG#--datadir=} ;;
-		"--sysconfdir="*)     SYSCONFDIR=${D}{ARG#--sysconfdir=} ;;
-		"--sharedstatedir="*) SHAREDSTATEDIR=${D}{ARG#--sharedstatedir=} ;;
-		"--localstatedir="*)  LOCALSTATEDIR=${D}{ARG#--localstatedir=} ;;
-		"--includedir="*)     INCLUDEDIR=${D}{ARG#--includedir=} ;;
-		"--infodir="*)        INFODIR=${D}{ARG#--infodir=} ;;
-		"--mandir"*)          MANDIR=${D}{ARG#--mandir} ;;
-		"--help"*) printhelp; exit 1 ;;
-	#foreach( $opt in $options )
-    	"--${opt.getArgument()}="*) ${opt.getVarName()}=${D}{ARG#--${opt.getArgument()}=} ;;
+        "--prefix="*)         prefix=${D}{ARG#--prefix=} ;;
+        "--exec-prefix="*)    exec_prefix=${D}{ARG#--exec-prefix=} ;;
+        "--bindir="*)         bindir=${D}{ARG#----bindir=} ;;
+        "--sbindir="*)        sbindir=${D}{ARG#--sbindir=} ;;
+        "--libdir="*)         libdir=${D}{ARG#--libdir=} ;;
+        "--libexecdir="*)     libexecdir=${D}{ARG#--libexecdir=} ;;
+        "--datarootdir="*)    datarootdir=${D}{ARG#--datarootdir=} ;;
+        "--datadir="*)        datadir=${D}{ARG#--datadir=} ;;
+        "--sysconfdir="*)     sysconfdir=${D}{ARG#--sysconfdir=} ;;
+        "--sharedstatedir="*) sharedstatedir=${D}{ARG#--sharedstatedir=} ;;
+        "--localstatedir="*)  localstatedir=${D}{ARG#--localstatedir=} ;;
+        "--includedir="*)     includedir=${D}{ARG#--includedir=} ;;
+        "--infodir="*)        infodir=${D}{ARG#--infodir=} ;;
+        "--mandir"*)          mandir=${D}{ARG#--mandir} ;;
+        "--localedir"*)       localedir=${D}{ARG#--localedir} ;;
+        "--help"*) printhelp; abort_configure ;;
+        "--debug")           BUILD_TYPE="debug" ;;
+        "--release")         BUILD_TYPE="release" ;;
+    #foreach( $opt in $options )
+        "--${opt.argument}="*) ${opt.varName}=${D}{ARG#--${opt.argument}=} ;;
     #end
-	#foreach( $feature in $features )
-		"--enable-${feature.arg}") ${feature.getVarName()}=on ;;
-		"--disable-${feature.arg}") unset ${feature.getVarName()} ;;
-	#end
-		"-"*) echo "unknown option: $ARG"; exit 1 ;;
-	esac
+    #foreach( $feature in $features )
+        "--enable-${feature.arg}") ${feature.varName}=on ;;
+        "--disable-${feature.arg}") unset ${feature.varName} ;;
+    #end
+        "-"*) echo "unknown option: $ARG"; abort_configure ;;
+    esac
 done
 
-# set dir variables
-if [ -z "$BINDIR" ]; then
-	BINDIR=$EPREFIX/bin
-fi
-if [ -z "$SBINDIR" ]; then
-	SBINDIR=$EPREFIX/sbin
-fi
-if [ -z "$LIBDIR" ]; then
-	LIBDIR=$EPREFIX/lib
-fi
-if [ -z "$LIBEXEC" ]; then
-	LIBEXECDIR=$EPREFIX/libexec
-fi
-if [ -z "$DATADIR" ]; then
-	DATADIR=$PREFIX/share
-fi
-if [ -z "$SYSCONFDIR" ]; then
-	SYSCONFDIR=$PREFIX/etc
-fi
-if [ -z "$SHAREDSTATEDIR" ]; then
-	SHAREDSTATEDIR=$PREFIX/com
-fi
-if [ -z "$LOCALSTATEDIR" ]; then
-	LOCALSTATEDIR=$PREFIX/var
-fi
-if [ -z "$INCLUDEDIR" ]; then
-	INCLUDEDIR=$PREFIX/include
-fi
-if [ -z "$INFODIR" ]; then
-	INFODIR=$PREFIX/info
-fi
-if [ -z "$MANDIR" ]; then
-	MANDIR=$PREFIX/man
+## Begin unparsed content. **
+#[[
+
+# set defaults for dir variables
+: ${exec_prefix:="$prefix"}
+: ${bindir:='${exec_prefix}/bin'}
+: ${sbindir:='${exec_prefix}/sbin'}
+: ${libdir:='${exec_prefix}/lib'}
+: ${libexecdir:='${exec_prefix}/libexec'}
+: ${datarootdir:='${prefix}/share'}
+: ${datadir:='${datarootdir}'}
+: ${sysconfdir:='${prefix}/etc'}
+: ${sharedstatedir:='${prefix}/com'}
+: ${localstatedir:='${prefix}/var'}
+: ${runstatedir:='${localstatedir}/run'}
+: ${includedir:='${prefix}/include'}
+: ${infodir:='${datarootdir}/info'}
+: ${mandir:='${datarootdir}/man'}
+: ${localedir:='${datarootdir}/locale'}
+
+# check if a config.site exists and load it
+if [ -n "$CONFIG_SITE" ]; then
+    # CONFIG_SITE may contain space separated file names
+    for cs in $CONFIG_SITE; do
+        printf "loading defaults from $cs... "
+        . "$cs"
+        echo ok
+    done
+elif [ -f "$prefix/share/config.site" ]; then
+    printf "loading site defaults... "
+    . "$prefix/share/config.site"
+    echo ok
+elif [ -f "$prefix/etc/config.site" ]; then
+    printf "loading site defaults... "
+    . "$prefix/etc/config.site"
+    echo ok
 fi
 
-which pkg-config > /dev/null
-if [ $? -eq 0 ]; then
-    PKG_CONFIG=pkg-config
-else
-    PKG_CONFIG=false
-fi
+# Test for availability of pkg-config
+PKG_CONFIG=`command -v pkg-config`
+: ${PKG_CONFIG:="false"}
 
 # Simple uname based platform detection
 # $PLATFORM is used for platform dependent dependency selection
+OS=`uname -s`
+OS_VERSION=`uname -r`
 printf "detect platform... "
-if [ $OS = SunOS ]; then
+if [ "$OS" = "SunOS" ]; then
     PLATFORM="solaris sunos unix svr4"
-fi
-if [ $OS = Linux ]; then
+elif [ "$OS" = "Linux" ]; then
     PLATFORM="linux unix"
-fi
-if [ $OS = FreeBSD ]; then
+elif [ "$OS" = "FreeBSD" ]; then
     PLATFORM="freebsd bsd unix"
-fi
-if [ $OS = Darwin ]; then
+elif [ "$OS" = "OpenBSD" ]; then
+    PLATFORM="openbsd bsd unix"
+elif [ "$OS" = "NetBSD" ]; then
+    PLATFORM="netbsd bsd unix"
+elif [ "$OS" = "Darwin" ]; then
     PLATFORM="macos osx bsd unix"
-fi
-echo $OS | grep "MINGW" > /dev/null
-if [ $? -eq 0 ]; then
+elif echo "$OS" | grep -i "MINGW" > /dev/null; then
     PLATFORM="windows mingw"
 fi
-
-if [ -z "$PLATFORM" ]; then
-    PLATFORM="unix"
-fi
+: ${PLATFORM:="unix"}
 
-for p in $PLATFORM
-do
-	PLATFORM_NAME=$p
-	break
-done
-echo $PLATFORM_NAME
+PLATFORM_NAME=`echo "$PLATFORM" | cut -f1 -d' ' -`
+echo "$PLATFORM_NAME"
 
 isplatform()
 {
     for p in $PLATFORM
     do
-        if [ $p = $1 ]; then
+        if [ "$p" = "$1" ]; then
             return 0
         fi
     done
     return 1
 }
-isnotplatform()
+notisplatform()
 {
     for p in $PLATFORM
     do
-        if [ $p = $1 ]; then
+        if [ "$p" = "$1" ]; then
+            return 1
+        fi
+    done
+    return 0
+}
+istoolchain()
+{
+    for t in $TOOLCHAIN
+    do
+        if [ "$t" = "$1" ]; then
+            return 0
+        fi
+    done
+    return 1
+}
+notistoolchain()
+{
+    for t in $TOOLCHAIN
+    do
+        if [ "$t" = "$1" ]; then
             return 1
         fi
     done
     return 0
 }
-
-# generate config.mk and config.h
-cat > $TEMP_DIR/config.mk << __EOF__
-#
-# config.mk generated by configure
-#
-
-# general vars
-#foreach( $var in $vars )
-${var.name}=$${var.name}
-#end
+]]#
+## End of unparsed content **
 
-#if ( ! $project.hasVar("PREFIX") )
-PREFIX=$PREFIX
-#end
-#if ( ! $project.hasVar("EPREFIX") )
-EPREFIX=$EPREFIX
-#end
-
-#if ( ! $project.hasVar("BINDIR") )
-BINDIR=$BINDIR
-#end
-#if ( ! $project.hasVar("SBINDIR") )
-SBINDIR=$SBINDIR
+# generate vars.mk
+cat > "$TEMP_DIR/vars.mk" << __EOF__
+prefix=$prefix
+exec_prefix=$exec_prefix
+bindir=$bindir
+sbindir=$sbindir
+libdir=$libdir
+libexecdir=$libexecdir
+datarootdir=$datarootdir
+datadir=$datadir
+sysconfdir=$sysconfdir
+sharedstatedir=$sharedstatedir
+localstatedir=$localstatedir
+runstatedir=$runstatedir
+includedir=$includedir
+infodir=$infodir
+mandir=$mandir
+localedir=$localedir
+#foreach( $var in $vars )
+${var.varName}=${D}${var.varName}
 #end
-#if ( ! $project.hasVar("LIBDIR") )
-LIBDIR=$LIBDIR
-#end
-#if ( ! $project.hasVar("LIBEXECDIR") )
-LIBEXECDIR=$LIBEXECDIR
-#end
-#if ( ! $project.hasVar("DATADIR") )
-DATADIR=$DATADIR
-#end
-#if ( ! $project.hasVar("SYSCONFDIR") )
-SYSCONFDIR=$SYSCONFDIR
-#end
-#if ( ! $project.hasVar("SHAREDSTATEDIR") )
-SHAREDSTATEDIR=$SHAREDSTATEDIR
-#end
-#if ( ! $project.hasVar("LOCALSTATEDIR") )
-LOCALSTATEDIR=$LOCALSTATEDIR
-#end
-#if ( ! $project.hasVar("INCLUDEDIR") )
-INCLUDEDIR=$INCLUDEDIR
-#end
-#if ( ! $project.hasVar("INFODIR") )
-INFODIR=$INFODIR
-#end
-#if ( ! $project.hasVar("MANDIR") )
-MANDIR=$MANDIR
-#end
-
 __EOF__
 
-echo > $TEMP_DIR/make.mk
-
-ENV_CFLAGS=$CFLAGS
-ENV_LDFLAGS=$LDFLAGS
-ENV_CXXFLAGS=$CXXFLAGS
-
-# Toolchain detection
-# this will insert make vars to config.mk
+# toolchain detection utilities
 . make/toolchain.sh
 
-# add user specified flags to config.mk
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${ENV_CFLAGS}" ]; then
-    echo "CFLAGS += $ENV_CFLAGS" >> $TEMP_DIR/config.mk
-fi
-if [ ! -z "${ENV_CXXFLAGS}" ]; then
-    echo "CXXFLAGS += $ENV_CXXFLAGS" >> $TEMP_DIR/config.mk
-fi
-if [ ! -z "${ENV_LDFLAGS}" ]; then
-    echo "LDFLAGS += $ENV_LDFLAGS" >> $TEMP_DIR/config.mk
-fi
-
 #
 # DEPENDENCIES
 #
 
-#foreach( $dependency in $namedDependencies )
-dependency_${dependency.name}()
+# check languages
+lang_c=
+lang_cpp=
+#foreach( $lang in $languages )
+if detect_${lang}_compiler ; then
+    lang_${lang}=1
+fi
+#end
+
+# create buffer for make variables required by dependencies
+echo > "$TEMP_DIR/make.mk"
+
+test_pkg_config()
 {
-    printf "checking for ${dependency.name}... "
-    #foreach( $sub in $dependency.getSubdependencies() )
-    # dependency $sub.name $sub.getPlatformString()
+    if "$PKG_CONFIG" --exists "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$2" ] || "$PKG_CONFIG" --atleast-version="$2" "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$3" ] || "$PKG_CONFIG" --exact-version="$3" "$1" ; then :
+    else return 1 ; fi
+    if [ -z "$4" ] || "$PKG_CONFIG" --max-version="$4" "$1" ; then :
+    else return 1 ; fi
+    return 0
+}
+
+print_check_msg()
+{
+    if [ -z "$1" ]; then
+        shift
+        printf "$@"
+    fi
+}
+
+#foreach( $dependency in $namedDependencies )
+dependency_error_${dependency.id}()
+{
+    print_check_msg "${D}dep_checked_${dependency.id}" "checking for ${dependency.name}... "
+    #foreach( $sub in $dependency.subdependencies )
+    # dependency $sub.fullName
     while true
     do
-    	#if( $sub.platform )
-    	if isnotplatform "${sub.platform}"; then
+        #if( $sub.platform )
+        if notisplatform "${sub.platform}"; then
+            break
+        fi
+        #end
+        #if( $sub.toolchain )
+        if notistoolchain "${sub.toolchain}"; then
+            break
+        fi
+        #end
+        #foreach( $np in $sub.notList )
+        if isplatform "${np}" || istoolchain "${np}"; then
             break
         fi
-    	#end
-		#foreach( $not in $sub.getNotList() )
-		if isplatform "${not}"; then
+        #end
+        #foreach( $lang in $sub.lang )
+        if [ -z "$lang_${lang}" ] ; then
             break
         fi
-		#end
+        #end
         #if( $sub.pkgconfig.size() > 0 )
         if [ -z "$PKG_CONFIG" ]; then
-        	break
+            break
+        fi
+        #end
+        #foreach( $test in $sub.tests )
+        if $test > /dev/null ; then
+            :
+        else
+            break
         fi
         #end
         #foreach( $pkg in $sub.pkgconfig )
-		$PKG_CONFIG $pkg.getPkgConfigParam()
-        if [ $? -ne 0 ] ; then
+        if test_pkg_config "$pkg.name" "$pkg.atleast" "$pkg.exact" "$pkg.max" ; then
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags $pkg.name`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs $pkg.name`"
+        else
             break
         fi
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags $pkg.getPkgConfigParam()`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs $pkg.getPkgConfigParam()`"
         #end
         #foreach( $flags in $sub.flags )
         #if( $flags.exec )
-        $flags.value > /dev/null
-        if [ $? -eq 0 ]; then
-            $flags.varName="$$flags.varName `$flags.value`"
+        if tmp_flags=`$flags.value` ; then
+            TEMP_$flags.varName="$TEMP_$flags.varName $tmp_flags"
         else
             break
         fi
         #else
-        $flags.varName="$$flags.varName $flags.value"    
+        TEMP_$flags.varName="$TEMP_$flags.varName $flags.value"
         #end
         #end
-        #foreach( $test in $sub.tests )
-        $test > /dev/null
-        if [ $? -ne 0 ]; then
-        	break
-        fi
-        #end
-		#if ( $sub.make.length() > 0 )
-		cat >> $TEMP_DIR/make.mk << __EOF__
-# Dependency: $dependency.name		
+        #if ( $sub.make.length() > 0 )
+        cat >> $TEMP_DIR/make.mk << __EOF__
+# Dependency: $dependency.name
 $sub.make
 __EOF__
         #end
-		echo yes
-        return 0
+        print_check_msg "${D}dep_checked_${dependency.id}" "yes\n"
+        dep_checked_${dependency.id}=1
+        return 1
     done
-	
-	#end
-	echo no
-	return 1
+
+    #end
+    print_check_msg "${D}dep_checked_${dependency.id}" "no\n"
+    dep_checked_${dependency.id}=1
+    return 0
 }
 #end
 
+# start collecting dependency information
+echo > "$TEMP_DIR/flags.mk"
+
 DEPENDENCIES_FAILED=
 ERROR=0
 #if( $dependencies.size() > 0 )
-# general dependencies
-CFLAGS=
-LDFLAGS=
+# unnamed dependencies
+TEMP_CFLAGS=
+TEMP_CXXFLAGS=
+TEMP_LDFLAGS=
 #foreach( $dependency in $dependencies )
 while true
 do
-	#if( $dependency.platform )
-    if isnotplatform "${dependency.platform}"; then
+    #if( $dependency.platform )
+    if notisplatform "${dependency.platform}"; then
+        break
+    fi
+    #end
+    #if( $dependency.toolchain )
+    if notistoolchain "${dependency.toolchain}"; then
         break
     fi
     #end
-	#foreach( $not in $dependency.getNotList() )
-    if isplatform "${not}"; then
+    #foreach( $np in $dependency.notList )
+    if isplatform "${np}" || istoolchain "${np}"; then
         break
     fi
-	#end
+    #end
     while true
     do
+        #foreach( $lang in $dependency.lang )
+        if [ -z "$lang_${lang}" ] ; then
+            ERROR=1
+            break
+        fi
+        #end
         #if( $dependency.pkgconfig.size() > 0 )
         if [ -z "$PKG_CONFIG" ]; then
             ERROR=1
@@ -412,54 +430,54 @@
         fi
         #end
         #foreach( $pkg in $dependency.pkgconfig )
-        printf "checking for pkg-config package $pkg.getPkgConfigParam()... "
-		$PKG_CONFIG $pkg.getPkgConfigParam()
-        if [ $? -ne 0 ]; then
-            echo no
+        print_check_msg "${D}dep_pkgconfig_checked_${pkg.id}" "checking for pkg-config package $pkg.name... "
+        if test_pkg_config "$pkg.name" "$pkg.atleast" "$pkg.exact" "$pkg.max" ; then
+            print_check_msg "${D}dep_pkgconfig_checked_${pkg.id}" "yes\n"
+            dep_pkgconfig_checked_${pkg.id}=1
+            TEMP_CFLAGS="$TEMP_CFLAGS `"$PKG_CONFIG" --cflags $pkg.name`"
+            TEMP_LDFLAGS="$TEMP_LDFLAGS `"$PKG_CONFIG" --libs $pkg.name`"
+        else
+            print_check_msg "${D}dep_pkgconfig_checked_${pkg.id}" "no\n"
+            dep_pkgconfig_checked_${pkg.id}=1
             ERROR=1
             break
         fi
-        echo yes
-        CFLAGS="$CFLAGS `$PKG_CONFIG --cflags $pkg.getPkgConfigParam()`"
-        LDFLAGS="$LDFLAGS `$PKG_CONFIG --libs $pkg.getPkgConfigParam()`"
         #end
-        
+
         #foreach( $flags in $dependency.flags )
         #if( $flags.exec )
         $flags.value > /dev/null
-        if [ $? -ne 0 ]; then
-            $flags.varName="$$flags.varName `$flags.value`"
+        if tmp_flags=`$flags.value` ; then
+            TEMP_$flags.varName="$TEMP_$flags.varName $tmp_flags"
         else
             ERROR=1
             break
         fi
         #else
-        $flags.varName="$$flags.varName $flags.value"    
+        TEMP_$flags.varName="$TEMP_$flags.varName $flags.value"
         #end
         #end
-		#if ( $dependency.make.length() > 0 )
-		cat >> $TEMP_DIR/make.mk << __EOF__
+        #if ( $dependency.make.length() > 0 )
+        cat >> "$TEMP_DIR/make.mk" << __EOF__
 $dependency.make
 __EOF__
         #end
-        
         break
     done
-    
     break
 done
 #end
 
-# add general dependency flags to config.mk
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${CFLAGS}" ]; then
-    echo "CFLAGS += $CFLAGS" >> $TEMP_DIR/config.mk
+# add general dependency flags to flags.mk
+echo "# general flags" >> "$TEMP_DIR/flags.mk"
+if [ -n "${TEMP_CFLAGS}" ] && [ -n "$lang_c" ]; then
+    echo "CFLAGS += $TEMP_CFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${CXXFLAGS}" ]; then
-    echo "CXXFLAGS += $CXXFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_CXXFLAGS}" ] && [ -n "$lang_cpp" ]; then
+    echo "CXXFLAGS += $TEMP_CXXFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${LDFLAGS}" ]; then
-    echo "LDFLAGS += $LDFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_LDFLAGS}" ]; then
+    echo "LDFLAGS += $TEMP_LDFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
 #end
 
@@ -470,25 +488,25 @@
 #foreach( $val in $opt.values )
 ${val.func}()
 {
-	VERR=0
-	#foreach( $dep in $val.dependencies )
-	dependency_$dep
-	if [ $? -ne 0 ]; then
-		VERR=1
-	fi
-	#end
-	if [ $VERR -ne 0 ]; then
-		return 1
-	fi
-	#foreach( $def in $val.defines )
-		CFLAGS="$CFLAGS ${def.toFlags()}"
-	#end
-	#if( $val.hasMake() )
-	cat >> $TEMP_DIR/make.mk << __EOF__
+    VERR=0
+    #foreach( $dep in $val.dependencies )
+    if dependency_error_$dep ; then
+        VERR=1
+    fi
+    #end
+    if [ $VERR -ne 0 ]; then
+        return 1
+    fi
+    #foreach( $def in $val.defines )
+        TEMP_CFLAGS="$TEMP_CFLAGS ${def.toFlags()}"
+        TEMP_CXXFLAGS="$TEMP_CXXFLAGS ${def.toFlags()}"
+    #end
+    #if( $val.hasMake() )
+    cat >> "$TEMP_DIR/make.mk" << __EOF__
 $val.make
 __EOF__
-	#end
-	return 0
+    #end
+    return 0
 }
 #end
 #end
@@ -496,120 +514,160 @@
 #
 # TARGETS
 #
-CFLAGS=
-CXXFLAGS=
-LDFLAGS=
 
 #foreach( $target in $targets )
+echo >> "$TEMP_DIR/flags.mk"
 #if ( $target.name )
-# Target: $target.name
+echo "configuring target: $target.name"
+echo "# flags for target $target.name" >> "$TEMP_DIR/flags.mk"
 #else
-# Target
+echo "configuring global target"
+echo "# flags for unnamed target" >> "$TEMP_DIR/flags.mk"
 #end
-CFLAGS=
-LDFLAGS=
-CXXFLAGS=
+TEMP_CFLAGS=
+TEMP_CXXFLAGS=
+TEMP_LDFLAGS=
 
 #foreach( $dependency in $target.dependencies )
-dependency_$dependency
-if [ $? -ne 0 ]; then
-	DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED ${dependency} "
-	ERROR=1
+if dependency_error_$dependency; then
+    DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED ${dependency} "
+    ERROR=1
 fi
 #end
 
 # Features
 #foreach( $feature in $target.features )
-if [ ! -z "$${feature.getVarName()}" ]; then
+if [ -n "${D}${feature.varName}" ]; then
 #foreach( $dependency in $feature.dependencies )
-	# check dependency
-	dependency_$dependency
-	if [ $? -ne 0 ]; then
-		# "auto" features can fail and are just disabled in this case
-		if [ $${feature.getVarName()} != "auto" ]; then
-			DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED ${dependency} "
-			ERROR=1
-		fi
-	fi
+    # check dependency
+    if dependency_error_$dependency ; then
+        # "auto" features can fail and are just disabled in this case
+        if [ "${D}${feature.varName}" = "auto" ]; then
+            DISABLE_${feature.varName}=1
+        else
+            DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED ${dependency} "
+            ERROR=1
+        fi
+    fi
 #end
+    if [ -n "$DISABLE_${feature.varName}" ]; then
+        unset ${feature.varName}
+    fi
 fi
 #end
 
 #foreach( $opt in $target.options )
 # Option: --${opt.argument}
-if [ -z ${D}${opt.getVarName()} ]; then
-	SAVED_ERROR=$ERROR
-	SAVED_DEPENDENCIES_FAILED=$DEPENDENCIES_FAILED
-	ERROR=0
-	while true
-	do
-		#foreach( $optdef in $opt.defaults )
-		#if( $optdef.platform )
-		if isplatform "$optdef.platform"; then
-		#end
-		$optdef.func
-		if [ $? -eq 0 ]; then
-			echo "  ${opt.argument}: ${optdef.valueName}" >> $TEMP_DIR/options
-			ERROR=0
-			break
-		fi
-		#if( $optdef.platform )
-		fi
-		#end
-		#end
-		break
-	done
-	if [ $ERROR -ne 0 ]; then
-		SAVED_ERROR=1
-	fi
-	ERROR=$SAVED_ERROR
-	DEPENDENCIES_FAILED=$SAVED_DEPENDENCIES_FAILED=
+if [ -z "${D}${opt.varName}" ]; then
+    echo "auto-detecting option '${opt.argument}'"
+    SAVED_ERROR="$ERROR"
+    SAVED_DEPENDENCIES_FAILED="$DEPENDENCIES_FAILED"
+    ERROR=1
+    while true
+    do
+        #foreach( $optdef in $opt.defaults )
+        #if( $optdef.platform )
+        if isplatform "$optdef.platform"; then
+        #end
+        if $optdef.func ; then
+            echo "  ${opt.argument}: ${optdef.valueName}" >> "$TEMP_DIR/options"
+            ERROR=0
+            break
+        fi
+        #if( $optdef.platform )
+        fi
+        #end
+        #end
+        break
+    done
+    if [ $ERROR -ne 0 ]; then
+        SAVED_ERROR=1
+        SAVED_DEPENDENCIES_FAILED="option '${opt.argument}' $SAVED_DEPENDENCIES_FAILED"
+    fi
+    ERROR="$SAVED_ERROR"
+    DEPENDENCIES_FAILED="$SAVED_DEPENDENCIES_FAILED"
 else
-	if false; then
-		false
-	#foreach( $optval in $opt.values )
-	elif [ ${D}${opt.getVarName()} = "${optval.value}" ]; then
-		echo "  ${opt.argument}: ${D}${opt.getVarName()}" >> $TEMP_DIR/options
-		$optval.func
-		if [ $? -ne 0 ]; then
-			ERROR=1
-		fi
-	#end
-	fi
+    echo "checking option ${opt.argument} = ${D}${opt.varName}"
+    if false; then
+        false
+    #foreach( $optval in $opt.values )
+    elif [ "${D}${opt.varName}" = "${optval.value}" ]; then
+        echo "  ${opt.argument}: ${D}${opt.varName}" >> $TEMP_DIR/options
+        if $optval.func ; then
+            :
+        else
+            ERROR=1
+            DEPENDENCIES_FAILED="option '${opt.argument}' $DEPENDENCIES_FAILED"
+        fi
+    #end
+    fi
 fi
 #end
 
-echo >> $TEMP_DIR/config.mk
-if [ ! -z "${CFLAGS}" ]; then
-    echo "${target.getCFlags()}  += $CFLAGS" >> $TEMP_DIR/config.mk
+if [ -n "${TEMP_CFLAGS}" ] && [ -n "$lang_c" ]; then
+    echo "${target.cFlags}  += $TEMP_CFLAGS" >> "$TEMP_DIR/flags.mk"
+fi
+if [ -n "${TEMP_CXXFLAGS}" ] && [ -n "$lang_cpp" ]; then
+    echo "${target.cxxFlags}  += $TEMP_CXXFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
-if [ ! -z "${CXXFLAGS}" ]; then
-    echo "${target.getCXXFlags()} += $CXXFLAGS" >> $TEMP_DIR/config.mk
+if [ "$BUILD_TYPE" = "debug" ]; then
+    if [ -n "$lang_c" ]; then
+        echo '${target.cFlags} += ${DEBUG_CC_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+    if [ -n "$lang_cpp" ]; then
+        echo '${target.cxxFlags} += ${DEBUG_CXX_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
 fi
-if [ ! -z "${LDFLAGS}" ]; then
-    echo "${target.getLDFlags()} += $LDFLAGS" >> $TEMP_DIR/config.mk
+if [ "$BUILD_TYPE" = "release" ]; then
+    if [ -n "$lang_c" ]; then
+        echo '${target.cFlags} += ${RELEASE_CC_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+    if [ -n "$lang_cpp" ]; then
+        echo '${target.cxxFlags} += ${RELEASE_CXX_FLAGS}' >> "$TEMP_DIR/flags.mk"
+    fi
+fi
+if [ -n "${TEMP_LDFLAGS}" ]; then
+    echo "${target.ldFlags} += $TEMP_LDFLAGS" >> "$TEMP_DIR/flags.mk"
 fi
 
 #end
+
+# final result
 if [ $ERROR -ne 0 ]; then
-	echo
-	echo "Error: Unresolved dependencies"
-	echo $DEPENDENCIES_FAILED
-	rm -Rf $TEMP_DIR
-	exit 1
+    echo
+    echo "Error: Unresolved dependencies"
+    echo "$DEPENDENCIES_FAILED"
+    abort_configure
 fi
 
 echo "configure finished"
 echo
 echo "Build Config:"
-echo "  PREFIX:    $PREFIX"
-echo "  TOOLCHAIN: $TOOLCHAIN_NAME"
+echo "  PREFIX:      $prefix"
+echo "  TOOLCHAIN:   $TOOLCHAIN_NAME"
 #if ( $options.size() > 0 )
 echo "Options:"
-cat $TEMP_DIR/options
+cat "$TEMP_DIR/options"
+#end
+#if ( $features.size() > 0 )
+echo "Features:"
+#foreach( $feature in $features )
+if [ -n "${D}${feature.varName}" ]; then
+echo "  $feature.name: on"
+else
+echo "  $feature.name: off"
+fi
+#end
 #end
 echo
-cat $TEMP_DIR/config.mk $TEMP_DIR/make.mk > config.mk
-rm -Rf $TEMP_DIR
 
+# generate the config.mk file
+cat > "$TEMP_DIR/config.mk" << __EOF__
+#
+# config.mk generated by configure
+#
 
+__EOF__
+write_toolchain_defaults "$TEMP_DIR/toolchain.mk"
+cat "$TEMP_DIR/vars.mk" "$TEMP_DIR/toolchain.mk" "$TEMP_DIR/flags.mk" "$TEMP_DIR/make.mk" > config.mk
+rm -Rf "$TEMP_DIR"
--- a/make/gcc.mk	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/gcc.mk	Sun Apr 07 11:26:38 2024 +0200
@@ -2,8 +2,13 @@
 # gcc toolchain config
 #
 
-CFLAGS = 
-LDFLAGS = 
+CFLAGS =
+CXXFLAGS =
+DEBUG_CC_FLAGS = -g
+DEBUG_CXX_FLAGS = -g
+RELEASE_CC_FLAGS = -O3 -DNDEBUG
+RELEASE_CXX_FLAGS = -O3 -DNDEBUG
+LDFLAGS =
 
 SHLIB_CFLAGS = -fPIC
 SHLIB_LDFLAGS = -shared
--- a/make/project.xml	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/project.xml	Sun Apr 07 11:26:38 2024 +0200
@@ -1,5 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<project>
+<project xmlns="http://unixwork.de/uwproj">
+	<dependency>
+		<lang>c</lang>
+	</dependency>
+
 	<dependency name="gtk4">
 		<pkgconfig>gtk+-4.0</pkgconfig>
 		<cflags>-DUI_GTK3</cflags>
@@ -24,6 +28,7 @@
 	<dependency name="winui" platform="windows">
 		<cflags>-DUI_WINUI</cflags>
 	</dependency>
+	<!--
 	<dependency name="qt4">
 		<test>which qmake-qt4</test>
 		<cflags type="exec">qmake-qt4 -o - /dev/null | grep DEFINES\ </cflags>
@@ -36,6 +41,7 @@
 		<cflags type="exec">qmake-qt5 -o - /dev/null | grep INCPATH\ </cflags>
 		<ldflags type="exec"><cflags type="exec">qmake-qt5 -o - /dev/null | grep LIBS\ </cflags></ldflags>
 	</dependency>
+	-->
 	<dependency name="cocoa" platform="macos">
 		<cflags>-DUI_COCOA</cflags>
 		<ldflags>-lobjc -framework Cocoa</ldflags>
--- a/make/suncc.mk	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/suncc.mk	Sun Apr 07 11:26:38 2024 +0200
@@ -2,8 +2,13 @@
 # suncc toolchain
 #
 
-CFLAGS = 
-LDFLAGS = 
+CFLAGS =
+CXXFLAGS =
+DEBUG_CC_FLAGS = -g
+DEBUG_CXX_FLAGS = -g
+RELEASE_CC_FLAGS = -O3 -DNDEBUG
+RELEASE_CXX_FLAGS = -O3 -DNDEBUG
+LDFLAGS =
 
 SHLIB_CFLAGS = -Kpic
 SHLIB_LDFLAGS = -G
--- a/make/toolchain.sh	Sun Mar 31 18:29:06 2024 +0200
+++ b/make/toolchain.sh	Sun Apr 07 11:26:38 2024 +0200
@@ -3,179 +3,198 @@
 # toolchain detection
 #
 
-C_COMPILERS="cc gcc clang suncc"
-CPP_COMPILERS="CC g++ clang++ sunCC"
-unset CC_ARG_CHECKED
-unset TOOLCHAIN_DETECTION_ERROR
+if isplatform "bsd" && notisplatform "openbsd"; then
+  C_COMPILERS="clang gcc cc"
+  CPP_COMPILERS="clang++ g++ CC"
+else
+  C_COMPILERS="gcc clang suncc cc"
+  CPP_COMPILERS="g++ clang++ sunCC CC"
+fi
+unset TOOLCHAIN
 unset TOOLCHAIN_NAME
+unset TOOLCHAIN_CC
+unset TOOLCHAIN_CXX
 
 check_c_compiler()
 {
-	cat > $TEMP_DIR/test.c << __EOF__
+  cat > "$TEMP_DIR/test.c" << __EOF__
 /* test file */
 #include <stdio.h>
 int main(int argc, char **argv) {
-#if defined(__clang__)
-	printf("clang\n");
+#if defined(_MSC_VER)
+  printf("msc\n");
+#elif defined(__clang__)
+  printf("clang gnuc\n");
 #elif defined(__GNUC__)
-	printf("gcc\n");
+  printf("gcc gnuc\n");
 #elif defined(__sun)
-	printf("suncc\n");
+  printf("suncc\n");
 #else
-	printf("unknown\n");
+  printf("unknown\n");
 #endif
-	return 0;
+  return 0;
 }
 __EOF__
-	rm -f $TEMP_DIR/checkcc
-	$1 -o $TEMP_DIR/checkcc $CFLAGS $LDFLAGS $TEMP_DIR/test.c 2> /dev/null
-	
-	if [ $? -ne 0 ]; then
-		return 1
-	fi
-	return 0
+  rm -f "$TEMP_DIR/checkcc"
+  $1 -o "$TEMP_DIR/checkcc" $CFLAGS $LDFLAGS "$TEMP_DIR/test.c" 2> /dev/null
 }
 
 check_cpp_compiler()
 {
-	cat > $TEMP_DIR/test.cpp << __EOF__
+  cat > "$TEMP_DIR/test.cpp" << __EOF__
 /* test file */
 #include <iostream>
 int main(int argc, char **argv) {
-#if defined(__clang__)
-	std::cout << "clang" << std::endl;
+#if defined(_MSC_VER)
+  std::cout << "msc" << std::endl;
+#elif defined(__clang__)
+  std::cout << "clang gnuc" << std::endl;
 #elif defined(__GNUC__)
-	std::cout << "gcc" << std::endl;
+  std::cout << "gcc gnuc" << std::endl;
 #elif defined(__sun)
-	std::cout << "suncc" << std::endl;
+  std::cout << "suncc" << std::endl;
 #else
-	std::cout << "unknown" << std::endl;
+  std::cout << "cc" << std::endl;
 #endif
-	return 0;
+  return 0;
+}
+__EOF__
+  rm -f "$TEMP_DIR/checkcc"
+  $1 -o "$TEMP_DIR/checkcc" $CXXFLAGS $LDFLAGS "$TEMP_DIR/test.cpp" 2> /dev/null
+}
+
+create_libtest_source()
+{
+  # $1: filename
+  # $2: optional include
+  cat > "$TEMP_DIR/$1" << __EOF__
+/* libtest file */
+int main(int argc, char **argv) {
+  return 0;
 }
 __EOF__
-	rm -f $TEMP_DIR/checkcc
-	$1 -o $TEMP_DIR/checkcc $CXXFLAGS $LDFLAGS $TEMP_DIR/test.cpp 2> /dev/null
-	
-	if [ $? -ne 0 ]; then
-		return 1
-	fi
-	return 0
+  if [ -n "$2" ]; then
+    echo "#include <$2>" >> "$TEMP_DIR/$1"
+  fi
+}
+
+check_c_lib()
+{
+  # $1: libname
+  # $2: optional include
+  if [ -z "$TOOLCHAIN_CC" ]; then
+    return 1
+  fi
+  create_libtest_source "test.c" "$2"
+  rm -f "$TEMP_DIR/checklib"
+  $TOOLCHAIN_CC -o "$TEMP_DIR/checklib" $CFLAGS $LDFLAGS "-l$1" "$TEMP_DIR/test.c" 2> /dev/null
+}
+
+check_cpp_lib()
+{
+  # $1: libname
+  # $2: optional include
+  if [ -z "$TOOLCHAIN_CXX" ]; then
+    return 1
+  fi
+  create_libtest_source "test.cpp" "$2"
+  rm -f "$TEMP_DIR/checklib"
+  $TOOLCHAIN_CXX -o "$TEMP_DIR/checklib" $CXXFLAGS $LDFLAGS "-l$1" "$TEMP_DIR/test.cpp" 2> /dev/null
+}
+
+check_lib()
+{
+  # $1: libname
+  # $2: optional include
+  if [ -n "$TOOLCHAIN_CC" ]; then
+    check_c_lib "$1" "$2"
+  elif  [ -n "$TOOLCHAIN_CXX" ]; then
+    check_cpp_lib "$1" "$2"
+  fi
 }
 
-printf "detect C compiler... "
+detect_c_compiler()
+{
+  if [ -n "$TOOLCHAIN_CC" ]; then
+    return 0
+  fi
+  printf "detect C compiler... "
+  if [ -n "$CC" ]; then
+    if check_c_compiler "$CC"; then
+      TOOLCHAIN_CC=$CC
+      TOOLCHAIN=`"$TEMP_DIR/checkcc"`
+      TOOLCHAIN_NAME=`echo "$TOOLCHAIN" | cut -f1 -d' ' -`
+      echo "$CC"
+      return 0
+    else
+      echo "$CC is not a working C compiler"
+      return 1
+    fi
+  else
+    for COMP in $C_COMPILERS
+    do
+      if check_c_compiler "$COMP"; then
+        TOOLCHAIN_CC=$COMP
+        TOOLCHAIN=`"$TEMP_DIR/checkcc"`
+        TOOLCHAIN_NAME=`echo "$TOOLCHAIN" | cut -f1 -d' ' -`
+        echo "$COMP"
+        return 0
+      fi
+    done
+    echo "not found"
+    return 1
+  fi
+}
 
-for COMP in $C_COMPILERS
-do
-	check_c_compiler $COMP
-	if [ $? -ne 0 ]; then
-		if [ ! -z "$CC" ]; then
-			if [ $COMP = $CC ]; then
-				echo "$CC is not a working C Compiler"
-				TOOLCHAIN_DETECTION_ERROR="error"
-				break
-			fi
-		fi
-	else
-		TOOLCHAIN_NAME=`$TEMP_DIR/checkcc`
-		USE_TOOLCHAIN=$TOOLCHAIN_NAME
-		if [ $COMP = "cc" ]; then
-			# we have found a working compiler, but in case
-			# the compiler is gcc or clang, we try to use
-			# these commands and not 'cc'
-			TOOLCHAIN_NAME=`$TEMP_DIR/checkcc`
-			if [ $TOOLCHAIN_NAME = "gcc" ]; then
-				check_c_compiler "gcc"
-				if [ $? -eq 0 ]; then
-					COMP=gcc
-					USE_TOOLCHAIN="gcc"
-				fi
-			fi
-			if [ $TOOLCHAIN_NAME = "clang" ]; then
-				check_c_compiler "clang"
-				if [ $? -eq 0 ]; then
-					COMP=clang
-					USE_TOOLCHAIN="clang"
-				fi
-			fi
-		fi
-		
-		TOOLCHAIN_NAME=$USE_TOOLCHAIN
-		TOOLCHAIN_CC=$COMP
-		echo $COMP
-		break
-	fi
-done
-if [ -z $TOOLCHAIN_CC ]; then
-	echo "not found"
-fi
-
-printf "detect C++ compiler... "
+detect_cpp_compiler()
+{
+  if [ -n "$TOOLCHAIN_CXX" ]; then
+    return 0
+  fi
+  printf "detect C++ compiler... "
 
-for COMP in $CPP_COMPILERS
-do
-	check_cpp_compiler $COMP
-	if [ $? -ne 0 ]; then
-		if [ ! -z "$CXX" ]; then
-			if [ $COMP = $CXX ]; then
-				echo "$CC is not a working C++ Compiler"
-				TOOLCHAIN_DETECTION_ERROR="error"
-				break
-			fi
-		fi
-	else
-		if [ $COMP = "CC" ]; then
-			# we have found a working compiler, but in case
-			# the compiler is gcc or clang, we try to use
-			# these commands and not 'cc'
-			TOOLCHAIN_NAME=`$TEMP_DIR/checkcc`
-			USE_TOOLCHAIN=$TOOLCHAIN_NAME
-			if [ $TOOLCHAIN_NAME = "gcc" ]; then
-				check_cpp_compiler "g++"
-				if [ $? -eq 0 ]; then
-				   COMP=g++
-				   USE_TOOLCHAIN="gcc"
-				fi
-			fi
-			if [ $TOOLCHAIN_NAME = "clang" ]; then
-				check_cpp_compiler "clang++"
-				if [ $? -eq 0 ]; then
-				   COMP=clang++
-				   USE_TOOLCHAIN="clang"
-				fi
-			fi
-		fi
-		
-		TOOLCHAIN_NAME=$USE_TOOLCHAIN
-		TOOLCHAIN_CXX=$COMP
-		echo $COMP
-		break
-	fi
-done
-if [ -z $TOOLCHAIN_CXX ]; then
-	echo "not found"
-fi
+  if [ -n "$CXX" ]; then
+    if check_cpp_compiler "$CXX"; then
+      TOOLCHAIN_CXX=$CXX
+      TOOLCHAIN=`"$TEMP_DIR/checkcc"`
+      TOOLCHAIN_NAME=`echo "$TOOLCHAIN" | cut -f1 -d' ' -`
+      echo "$CXX"
+      return 0
+    else
+      echo "$CXX is not a working C++ compiler"
+      return 1
+    fi
+  else
+    for COMP in $CPP_COMPILERS
+    do
+      if check_cpp_compiler "$COMP"; then
+        TOOLCHAIN_CXX=$COMP
+        TOOLCHAIN=`"$TEMP_DIR/checkcc"`
+        TOOLCHAIN_NAME=`echo "$TOOLCHAIN" | cut -f1 -d' ' -`
+        echo "$COMP"
+        return 0
+      fi
+    done
+    echo "${TOOLCHAIN_CXX:-"not found"}"
+    return 1
+  fi
+}
 
-TOOLCHAIN_LD=$TOOLCHAIN_CC
-
-if [ -z "$TOOLCHAIN_NAME" ]; then
-	TOOLCHAIN_DETECTION_ERROR="error"
-else
-	cat >> $TEMP_DIR/config.mk << __EOF__
-# toolchain
-__EOF__
-	echo "CC = ${TOOLCHAIN_CC}" >> $TEMP_DIR/config.mk
-	if [ ! -z "$TOOLCHAIN_CXX" ]; then
-		echo "CXX = ${TOOLCHAIN_CXX}" >> $TEMP_DIR/config.mk
-	fi
-	echo "LD = ${TOOLCHAIN_LD}" >> $TEMP_DIR/config.mk
-	echo >> $TEMP_DIR/config.mk
-	
-	cat "make/${TOOLCHAIN_NAME}.mk" > /dev/null 2>&1
-	if [ $? -eq 0 ]; then 
-		echo "include \$(BUILD_ROOT)/make/${TOOLCHAIN_NAME}.mk" >> $TEMP_DIR/config.mk
-	else
-		echo "SHLIB_CFLAGS = -fPIC" >> $TEMP_DIR/config.mk
-		echo "SHLIB_LDFLAGS = -shared" >> $TEMP_DIR/config.mk
-	fi
-fi
+write_toolchain_defaults()
+{
+  echo "# toolchain" >> "$1"
+  if [ -n "$TOOLCHAIN_CC" ]; then
+    echo "CC = ${TOOLCHAIN_CC}" >> "$1"
+  fi
+  if [ -n "$TOOLCHAIN_CXX" ]; then
+    echo "CXX = ${TOOLCHAIN_CXX}" >> "$1"
+  fi
+  echo >> "$1"
+  if [ -f "make/${TOOLCHAIN_NAME}.mk" ]; then
+    cat "make/${TOOLCHAIN_NAME}.mk" >> "$1"
+  elif [ -f "make/cc.mk" ]; then
+    cat "make/cc.mk" >> "$1"
+  else
+    echo "!!! WARNING !!! Default toolchain flags not found. Configuration might be incomplete."
+  fi
+}
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/make/uwproj.xsd	Sun Apr 07 11:26:38 2024 +0200
@@ -0,0 +1,287 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
+           xmlns="http://unixwork.de/uwproj"
+           targetNamespace="http://unixwork.de/uwproj"
+           elementFormDefault="qualified"
+           version="0.2"
+>
+    <xs:element name="project" type="ProjectType"/>
+
+    <xs:complexType name="ProjectType">
+        <xs:annotation>
+            <xs:documentation>
+                The root element of an uwproj project.
+                Consists of an optional <code>config</code> element
+                and an arbitrary number of <code>dependency</code>
+                and <code>target</code> elements.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:sequence>
+            <xs:element name="config" type="ConfigType" minOccurs="0"/>
+            <xs:element name="dependency" type="DependencyType" minOccurs="0" maxOccurs="unbounded"/>
+            <xs:element name="target" type="TargetType" minOccurs="0" maxOccurs="unbounded"/>
+        </xs:sequence>
+    </xs:complexType>
+
+    <xs:complexType name="ConfigType">
+        <xs:annotation>
+            <xs:documentation>
+                The configuration section.
+                Consists of an arbitrary number of <code>var</code> elements.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:sequence>
+            <xs:element name="var" type="ConfigVarType" minOccurs="0" maxOccurs="unbounded"/>
+        </xs:sequence>
+    </xs:complexType>
+
+    <xs:complexType name="ConfigVarType">
+        <xs:annotation>
+            <xs:documentation>
+                The definition of a configuration variable.
+                <p>
+                    Configuration variables are supposed to be used in the configure script and are also
+                    written to the resulting config file (in contrast to make variables, which are only
+                    written to the config file).
+                    The <code>name</code> attribute is mandatory, the value is defined by the text body of the element.
+                    The optional Boolean <code>exec</code> attribute (false by default) controls, whether the entire
+                    definition is automatically executed under command substitution.
+                </p>
+            </xs:documentation>
+        </xs:annotation>
+        <xs:simpleContent>
+            <xs:extension base="xs:string">
+                <xs:attribute name="name" type="xs:string" use="required"/>
+                <xs:attribute name="exec" type="xs:boolean" default="false"/>
+            </xs:extension>
+        </xs:simpleContent>
+    </xs:complexType>
+
+    <xs:complexType name="PkgConfigType">
+        <xs:annotation>
+            <xs:documentation>
+                Instructs configure to invoke <code>pkg-config</code>, if present on the system, to determine
+                compiler and linker flags. The text body of this element defines the package name to search.
+                To constrain the allowed versions, use the attributes <code>atleast, exact, max</code>.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:simpleContent>
+            <xs:extension base="xs:string">
+                <xs:attribute name="atleast" type="xs:string"/>
+                <xs:attribute name="exact" type="xs:string"/>
+                <xs:attribute name="max" type="xs:string"/>
+            </xs:extension>
+        </xs:simpleContent>
+    </xs:complexType>
+
+    <xs:simpleType name="LangType">
+        <xs:annotation>
+            <xs:documentation>
+                Requests a compiler for the specified language. Allowed values are
+                c, cpp.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:restriction base="xs:string">
+            <xs:enumeration value="c"/>
+            <xs:enumeration value="cpp"/>
+        </xs:restriction>
+    </xs:simpleType>
+
+    <xs:complexType name="DependencyType">
+        <xs:annotation>
+            <xs:documentation>
+                Declares a dependency.
+                <p>
+                    If the optional <code>name</code> attribute is omitted, the dependency is global
+                    and must be satisfied, otherwise configuration shall fail.
+                    A <em>named dependency</em> can be referenced by a target (or is implicitly referenced
+                    by the default target, if no targets are specified).
+                    Multiple declarations for the same named dependency may exist, in which case each declaration
+                    is checked one after another, until one block is satisfied. The result of the first satisfied
+                    dependency declaration is supposed to be applied to the config file.
+                </p>
+                <p>
+                    The optional <code>platform</code> attribute may specify a <em>single</em> platform identifier and
+                    the optional <code>toolchain</code> attribute may specify a <em>single</em> toolchain.
+                    The optional <code>not</code> attribute may specify a comma-separated list of platform and/or
+                    toolchain identifiers.
+                    The configure script shall skip this dependency declaration if the detected platform and toolchain
+                    is not matching the filter specification of these attributes.
+                </p>
+            </xs:documentation>
+        </xs:annotation>
+        <xs:choice minOccurs="0" maxOccurs="unbounded">
+            <xs:element name="lang" type="LangType"/>
+            <xs:element name="cflags" type="FlagsType"/>
+            <xs:element name="cxxflags" type="FlagsType"/>
+            <xs:element name="ldflags" type="FlagsType"/>
+            <xs:element name="pkgconfig" type="PkgConfigType"/>
+            <xs:element name="test" type="xs:string">
+                <xs:annotation>
+                    <xs:documentation>
+                        Specifies a custom command that shall be executed to test whether this dependency is satisfied.
+                    </xs:documentation>
+                </xs:annotation>
+            </xs:element>
+            <xs:element name="make" type="MakeVarType"/>
+        </xs:choice>
+        <xs:attribute name="name" type="xs:string"/>
+        <xs:attribute name="platform" type="xs:string"/>
+        <xs:attribute name="toolchain" type="xs:string"/>
+        <xs:attribute name="not" type="xs:string"/>
+    </xs:complexType>
+
+    <xs:complexType name="FlagsType">
+        <xs:annotation>
+            <xs:documentation>
+                Instructs configure to append the contents of the element's body to the respective flags variable.
+                If the optional <code>exec</code> flag is set to <code>true</code>, the contents are supposed to be
+                executed under command substitution <em>at configuration time</em> before they are applied.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:simpleContent>
+            <xs:extension base="xs:string">
+                <xs:attribute name="exec" type="xs:boolean" default="false"/>
+            </xs:extension>
+        </xs:simpleContent>
+    </xs:complexType>
+
+    <xs:complexType name="TargetType">
+        <xs:annotation>
+            <xs:documentation>
+                Declares a build target that is supposed to be configured.
+                <p>
+                    If no build target is declared explicitly, an implicit default
+                    target is generated, which has the <code>alldependencies</code>
+                    flag set.
+                </p>
+                <p>
+                    The optional <code>name</code> attribute is also used to generate a prefix
+                    for the compiler and linker flags variables.
+                    Furthermore, a target may consist of an arbitrary number of <code>feature</code>,
+                    <code>option</code>, and <code>define</code> elements.
+                    Named dependencies can be listed (separated by comma) in the <code>dependencies</code>
+                    element. If this target shall use <em>all</em> available named dependencies, the empty
+                    element <code>alldependencies</code> can be used as a shortcut.
+                </p>
+            </xs:documentation>
+        </xs:annotation>
+        <xs:choice minOccurs="0" maxOccurs="unbounded">
+            <xs:element name="feature" type="FeatureType"/>
+            <xs:element name="option" type="OptionType"/>
+            <xs:element name="define" type="DefineType"/>
+            <xs:element name="dependencies" type="DependenciesType"/>
+            <xs:element name="alldependencies">
+                <xs:complexType/>
+            </xs:element>
+        </xs:choice>
+        <xs:attribute name="name" type="xs:string"/>
+    </xs:complexType>
+
+    <xs:complexType name="FeatureType">
+        <xs:annotation>
+            <xs:documentation>
+                Declares an optional feature, that can be enabled during configuration, if all
+                <code>dependencies</code> are satisfied.
+                If a feature is enabled, all <code>define</code> and <code>make</code> definitions are
+                supposed to be applied to the config file.
+                In case the optional <code>default</code> attribute is set to true, the feature is enabled by default
+                and is supposed to be automatically disabled (without error) when the dependencies are not satisfied.
+                The name that is supposed to be used for the --enable and --disable arguments can be optionally
+                specified with the <code>arg</code> attribute. Otherwise, the <code>name</code> is used by default.
+                Optionally, a description for the help text of the resulting configure script can be specified by
+                adding a <code>desc</code> element.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:choice minOccurs="0" maxOccurs="unbounded">
+            <xs:group ref="TargetDataGroup"/>
+        </xs:choice>
+        <xs:attribute name="name" type="xs:string" use="required"/>
+        <xs:attribute name="arg" type="xs:string"/>
+        <xs:attribute name="default" type="xs:boolean" default="false"/>
+        <xs:element name="desc" type="xs:string"/>
+    </xs:complexType>
+
+    <xs:complexType name="OptionType">
+        <xs:annotation>
+            <xs:documentation>
+                Declares a configuration option.
+                The option argument name is specified with the <code>arg</code> attribute.
+                Then, the children of this element specify possible <code>values</code> by defining the conditions
+                (in terms of dependencies) and effects (in terms of defines and make variables) of each value.
+                Finally, a set of <code>default</code>s is specified which supposed to automagically select the most
+                appropriate value for a specific platform under the available dependencies (in case the option is not
+                explicitly specified by using the command line argument).
+            </xs:documentation>
+        </xs:annotation>
+        <xs:sequence>
+            <xs:element name="value" type="OptionValueType" minOccurs="0" maxOccurs="unbounded"/>
+            <xs:element name="default" type="OptionDefaultType" minOccurs="0" maxOccurs="unbounded"/>
+        </xs:sequence>
+        <xs:attribute name="arg" type="xs:string" use="required"/>
+    </xs:complexType>
+
+    <xs:complexType name="OptionValueType">
+        <xs:annotation>
+            <xs:documentation>
+                Declares a possible value for the option (in the <code>str</code> attribute) and
+                the conditions (<code>dependencies</code>) and effects, the value has.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:choice minOccurs="0" maxOccurs="unbounded">
+            <xs:group ref="TargetDataGroup"/>
+        </xs:choice>
+        <xs:attribute name="str" type="xs:string" use="required"/>
+    </xs:complexType>
+
+    <xs:complexType name="OptionDefaultType">
+        <xs:annotation>
+            <xs:documentation>
+                Specifies a default value for this option. Multiple default values can be specified, in which case
+                they are checked one after another for availability. With the optional <code>platform</code> attribute,
+                the default value can be constrained to a <em>single</em> specific platform and is supposed to be
+                skipped by configure, when this platform is not detected.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:attribute name="value" type="xs:string" use="required"/>
+        <xs:attribute name="platform" type="xs:string"/>
+    </xs:complexType>
+
+    <xs:group name="TargetDataGroup">
+        <xs:choice>
+            <xs:element name="define" type="DefineType" minOccurs="0" maxOccurs="unbounded"/>
+            <xs:element name="dependencies" type="DependenciesType" minOccurs="0" maxOccurs="unbounded"/>
+            <xs:element name="make" type="MakeVarType" minOccurs="0" maxOccurs="unbounded"/>
+        </xs:choice>
+    </xs:group>
+
+    <xs:complexType name="DefineType">
+        <xs:annotation>
+            <xs:documentation>
+                Specifies C/C++ pre-processor definitions that are supposed to
+                be appended to the compiler flags, if supported.
+                (Note: for example, Fortran also supports C/C++ style pre-processor definitions under
+                certain circumstances)
+            </xs:documentation>
+        </xs:annotation>
+        <xs:attribute name="name" type="xs:string" use="required"/>
+        <xs:attribute name="value" type="xs:string"/>
+    </xs:complexType>
+
+    <xs:simpleType name="DependenciesType">
+        <xs:annotation>
+            <xs:documentation>A comma-separated list of named dependencies.</xs:documentation>
+        </xs:annotation>
+        <xs:restriction base="xs:string"/>
+    </xs:simpleType>
+
+    <xs:simpleType name="MakeVarType">
+        <xs:annotation>
+            <xs:documentation>
+                The text contents in the body of this element are supposed to be appended literally
+                to the config file without prior processing.
+            </xs:documentation>
+        </xs:annotation>
+        <xs:restriction base="xs:string"/>
+    </xs:simpleType>
+</xs:schema>

mercurial